package othello;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import othello.model.* ;
import othello.view.* ;
/**
 * <p>Title: Othello</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Memorial University</p>
 * @author Theodore Norvell
 * @version 1.0
 */

public class TestMain1 implements GameConstants {
    
    public static void main(String[] args) {
        GameModel gameModel = new GameModel() ;
        
        Animator animator0 = new Animator( gameModel ) ;
        Animator animator1 = new Animator( gameModel ) ;
        ViewStrategy birdsEye = new BirdsEyeViewStrategy() ;
        ViewStrategy perspective = new PerspectiveViewStrategy() ;
        
        BoardView view0 = new BoardView( animator0, birdsEye ) ;
        JFrame frame0 = new JFrame() ;
        frame0.setDefaultCloseOperation( WindowConstants.EXIT_ON_CLOSE ) ;
        frame0.add( view0 ) ;
        frame0.setSize(350, 350);
        frame0.setVisible( true );
        
        
        BoardView view1 = new BoardView( animator1, birdsEye ) ;
        JFrame frame1 = new JFrame() ;
        frame1.setDefaultCloseOperation( WindowConstants.EXIT_ON_CLOSE ) ;
        frame1.add( view1 ) ;
        frame1.setBounds(350, 0, 350, 350);
        frame1.setVisible( true );
        
        BoardView view2 = new BoardView( animator0, perspective ) ;
        JFrame frame2 = new JFrame() ;
        frame2.setDefaultCloseOperation( WindowConstants.EXIT_ON_CLOSE ) ;
        frame2.add( view2 ) ;
        frame2.setBounds(0, 350, 350, 350);
        frame2.setVisible( true );
        
        
        BoardView view3 = new BoardView( animator1, perspective ) ;
        JFrame frame3 = new JFrame() ;
        frame3.setDefaultCloseOperation( WindowConstants.EXIT_ON_CLOSE ) ;
        frame3.add( view3 ) ;
        frame3.setBounds(350, 350, 350, 350);
        frame3.setVisible( true );
        
        gameModel.layPiece(4,4,WHITE);    
        gameModel.layPiece(4,5,BLACK);
        gameModel.layPiece(5,5,WHITE);
        gameModel.layPiece(5,4,BLACK);
        
        gameModel.layPiece(3,4, BLACK);
        gameModel.flipPiece(4,4);

        gameModel.layPiece(3,3, WHITE);
        gameModel.flipPiece(4,4);

        gameModel.layPiece(4,3, BLACK);
        gameModel.flipPiece(4,4);
        
        gameModel.layPiece(5,3, WHITE);
        gameModel.flipPiece(4,3);
        gameModel.flipPiece(5,4);

        gameModel.layPiece(2,2, BLACK);
        gameModel.flipPiece(3,3);
    }
        
}