package othello.model;

import othello.observation.* ;

/**
 * <p>Title: GameModel</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Memorial University</p>
 * @author Theodore S. Norvell
 * @version 1.0
 */
public class GameModel extends ConcurrentlyObservable
implements GameModelInterface {

    private int [][] square = new int[ROWS][COLS] ;
    {
        for( int r=0 ; r<ROWS ; ++r ) {
            for( int c=0 ; c<COLS ; ++c ) {
                square[r][c] = EMPTY ; } }
    }
    
    public void layPiece( int row, int col, int bw) {
		writerEnters() ;
		try {
            square[row][col] = bw ;
            notifyObservers( new Pair(row,col) ) ; }
        finally { writerExits() ; } }
        
    public void flipPiece( int row, int col ) {
		writerEnters() ;
		try {
			if( square[row][col] == BLACK ) square[row][col] = WHITE ;
			else                            square[row][col] = BLACK ;
			notifyObservers( new Pair(row,col) ); }
		finally { writerExits() ; } }
        
    public int getPieceAt( int row, int col ) {
    	readerEnters() ;
    	try {
    		return square[row][col] ; }
    	finally { readerExits() ; } }
}
